#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#define TEST_TS 1199062800

void TestIt(const char *fileName, int withWrite) {
	int h;
	struct timeval ts[2];
	struct stat buf;	
	int dummy;

	printf("create %s\n", fileName);
	h = open(fileName, O_CREAT|O_RDWR|O_TRUNC);
	if (h == -1) {
		printf("unable to create %s\n", fileName);
		return;
	}
	if (withWrite) {
	   dummy = 1234;
	   printf("write some data\n");
	   if (write(h, &dummy, sizeof(dummy)) != sizeof(dummy)) {
		printf("unable to write\n");
	   }
	}
	fsync(h);
	ts[0].tv_sec = TEST_TS;
	ts[0].tv_usec = 0;
	ts[1].tv_sec = TEST_TS;
	ts[1].tv_usec = 0;
	if (futimes(h, ts) < 0)  {
		printf("unable to futimes\n");
	}
	close(h);
	if (stat(fileName, &buf) < 0) {
		printf("unable to stat %s\n", fileName);
		return;
	}
	printf("reftime=%d atime=%d mtime=%d\n", TEST_TS, (int)buf.st_atime, (int)buf.st_mtime);
	if (buf.st_mtime != TEST_TS) {
		printf("wrong mtime !!!\n");
	}
}

int main() {
	TestIt("./t1.bin", 0);
	TestIt("./t2.bin", 1);
}